#!/usr/bin/perl
# pcBot Lia v1.6 - Under Development :)
# by pcHazard and struck
#
#  Faca:
#    ./pcbot.pl &
#    tail -f pcbot.log
#
# ChangeLog
# 06 Fev 2002 struck
#             - Implementacao na engine de conversacao
#             - Adicionada a funcao extra !executa
#
# 07 Fev 2002 pcHazard
#             - Adicionado suporte a arquivo de configuracao
#             - Adicionado suporte a rehasing do arquivo de configuracao
#             - As variavel $bogus agora eh uma hash, assim cada pessoa pode ter
#               seu proprio valor para bogus agora...
# 08 Fev 2002 struck
#             - Adicionada as funcoes !private e !talk
#             - Adicionada controle de BADWORDS
#

use IO::Socket;
use IO::Handle;

my $sock;
my $server  = $ARGV[0] || 'irc.brasnet.org';
my $port    = $ARGV[1] || '6667';
my $meunick = $ARGV[2] || 'lia16a';
my @canais  = splice(@ARGV, 3, $#ARGV) || ('#fashion_eh_meu_ovo','#unsekure','#beltrao');
my (@joinmsg, @unknowmsg, @oimsg, @naomsg, @bommsg, @malmsg,  @othermsg, @quitmsg, @partmsg,
    @scums, @badmsg, @ownerlist, @conversionlist);

$private = "desligado!";
$myowner = "struck";

if ($ARGV[0] eq '--help')
{
   print "\n=[ pcBot ]=======================================\n";
   print "Uso: $0 [servidor] [porta] [nick] ([canal1] ... )\n\n";
   exit(-1);
}


open(FDEBUG,    "> pcbot.log");
open(RAW,       "> raw.log");
open(NOTPARSED, "> noparsed.log");

rehash();
#testhash();


sub interrupt
{
   debuga("Recebido um sinal de interrupcao...");
   foreach $c (@canais)
   {
      privmsg($c, random_txt("partmsg"));
   }
   print $sock "QUIT :".random_txt("quitmsg")."\n";
   close(FDEBUG);
   close($sock);
   exit(-1);
}
$SIG{'INT'}=$SIG{'TERM'}=\&interrupt;

sub sighup
{
   debuga("REHASH received...");
   foreach $c (@canais)
   {
      privmsg($c, random_txt("rehashmsg"));
   }
   rehash();

}
$SIG{'HUP'}=\&sighup;


debuga("Conectando em $server:$port ...");
$sock = IO::Socket::INET->new(Proto => "tcp",
                              PeerAddr => $server,
                              PeerPort => $port);
unless ($sock)
{
   debuga("Erro conectando: $!");
   print "[-] Erro conectando em $server:$port : $!\n" ;
   exit (-1);
}
print "[+] Connected. Going to background...\n";
debuga("Conectado.");
debuga("Going to background...");
exit(0) if (fork() != 0);
debuga("Done.");

print $sock "NICK $meunick\n";
print $sock "USER Aline Aline Aline Aline\n";

debuga("Entering in main loop...");
while (<$sock>)
{
   chop;
   $rawcmds = $_;
   @linhas = split("\n",$rawcmds);

   foreach $linha (@linhas)
   {
      parseirc($linha);
   }
}

sub parseirc
{
   chop;
   next if ($_ eq '');
   $linha = $_;
   @args = split(" ",$linha);
   $cmd  = $args[1];
   
   print RAW "$linha\n";
   if ($cmd eq 'JOIN')
   {
      $nick   = substr($linha,1,strpos($linha,"!")-1);
      $canal  = substr($args[2],1,length($args[2]));
      debuga("--> JOIN $nick entrou no canal $canal !!!");

      if ($nick eq "$meunick")
      {
         debuga("Eu entrei no $canal !!!");
         privmsg($canal, random_txt("joinmsg"));
      }
      elsif (uc($nick) eq 'STRUCK')
      {
         privmsg($canal, "strucko: ti amo gatinho!!!!!!!!! :*******");
      }
      elsif (uc($nick) eq 'PCHAZARD')
      {
         privmsg($canal, "hazard gostosao, estava te esperando hihih :)");
      }
      
   }
   elsif ($cmd eq 'PART')
   {
      #:^^ispirokado!ifdrg@msmeUwuTB6Q.200.193.198.O PART #anapolis
      substr($linha,0,1) = "";
      $nick   = substr($linha,0,strpos($linha,"!"));
      $de     = $args[2];
      if (uc($nick) eq 'STRUCK')
      {
         privmsg($canal,"Que pena que o struck foi embora... :~");
      }
      elsif (uc($nick) eq 'PCHAZARD')
      {
         privmsg($canal,"ahhh vai naum :~");
      }
   }
   elsif ($cmd eq 'PRIVMSG')
   {
      #:flash!~Mafioso@0vlnxLBN9Tg.200.177.43.O PRIVMSG #unsekure :iauhiauha
      substr($linha,0,1) = "";
      $de     = substr($linha,0,strpos($linha,"!"));
      $para   = $args[2];
      $txt    = substr($linha,strpos($linha,":")+1,length($linha));
      
      if (substr($txt,0,1) eq '!')  {
         run_owner_command($de, $txt);
      }
      elsif ($de eq "$private")
      {
         $resposta="<$de:$para> $txt";
         privmsg($myowner,$resposta);
      }
      elsif ($para eq "$meunick")
      {
         debuga("--> PRIVMSG de $de para mim: ($txt)");
         handle_privmsgs($de, $para, $txt);
      }
      else
      {
         if (thereis("$meunick"," $txt "))
         {
            debuga("--> CHANNEL MSG para mim no canal $canal de $de: ($txt)");
            handle_privmsgs($de, $para, $txt);
         }
      }
   }
   elsif ($cmd eq 'NICK')
   {
      #:`flash`!~Mafioso@l7J62tYD8pk.for.terra.com.br NICK :flash
      substr($linha,0,1) = "";
      $de     = substr($linha,0,strpos($linha,"!")-1);
      $para   = substr($linha,strpos($linha,":")+1,length($linha));
      debuga("--> NICK $de mudou o nick para $para");
   }
   elsif ($cmd eq 'KICK')
   {
      substr($linha,0,1) = "";
      $kicker = substr($linha,0,strpos($linha,"!")-1);
      $onde   = $args[2];
      $razao  = substr($linha,strpos($linha,":")+1,length($linha));
      debuga("--> KICK de $kicker em $onde por $kicker ($razao)");
   }
   elsif ($args[0] eq "PING")
   {
      $repl   = $linha;
      substr($repl,0,4) = "PONG";
      print $sock "$repl\n";
      debuga("--> PING?PONG! ($repl)");
   }
   elsif ($cmd eq "376")  # fim do MOTD
   {
      debuga("--> Fim do MOTD. Entrando nos canais...");
      foreach $canal (@canais)
      {
         debuga("--> Entrando no $canal...");
         print $sock "JOIN $canal\n";
      }
   }
   else
   {
      print NOTPARSED datahora()." -> $linha\n";
   }
}

sub handle_privmsgs
{
   ($de, $para, $txt) = @_;
   $ude = uc($de);

   debuga("<$de> $txt");
   $cleaned = uc(limpatxts("$txt"));

   if (check($cleaned,"?"))
   {
      # Eh uma questao interrogativa ?
      $msgtype = 1;
   }
   elsif (check($cleaned,"!"))
   {
      # Eh uma questao afirmativa !
      $msgtype = 2;
   }
   else
   {
      # Eh uma merda qq...
      $msgtype=3;
   }

   if (check($cleaned,"PING"))   {
      $resposta = "pare de me pingar!!";
   }
   elsif (check($cleaned,"BOM"))   {
      if ($msgtype == 1) {
         $resposta = "bem, e vc ?";
      }
      else {
         $resposta = random_txt("bommsg");
      }
   }
   elsif (check($cleaned, "OI"))  {
      $resposta = random_txt("oimsg");
      $bogus{"$ude"} = 7;
   }
   elsif ((check($cleaned,"TECLAR"))) {
      if ($msgtype == 1)  {
         $resposta = random_txt("simmsg");
      }
      else {
         $resposta = random_txt("unknowmsg");
      }
   }
   elsif ((check($cleaned,"SABE"))) {
      if ($msgtype == 1)  {
         $resposta = "sei";
      }
      else {
         $resposta = "ah! fala serio!";
      }
   }
   elsif (check($cleaned,"MAL"))  {
      if ($msgtype == 1) {
         $resposta = random_txt("unknowmsg");
      }
      else {
         $resposta = random_txt("malmsg");;
      }
   }
   elsif (check($cleaned,"NAMORADO")) {
      if ($msgtype == 1) { 
         $resposta = "eu nao e vc, tem namorada ?"; 
         $bogus{"$ude"} = 3;
      }
      else {
         $resposta = random_txt("unknowmsg");
      }
   }
   elsif ((check($cleaned,"NAMORAR")) || (check($cleaned,"BEIJAR")) ) {
      if ($msgtype == 1)  {
         $resposta = "hmm... acho q ainda eh cedo prum relacionamento :)";
      }
      else {
         $resposta = random_txt("unknowmsg");
      }
   }
   elsif (check($cleaned,"IDADE")) {
      if ($msgtype == 1) { 
         $resposta = "eu tenho 16 e voce?"; 
         $bogus{"$ude"} = 1;
      }
      else  {
         $resposta = "mulheres nao gostam de falar sobre a idade :))";
      }
   }
   elsif (check($cleaned,"ONDE")) {
      if ($msgtype == 1) {
         $resposta = "eu tc d anapolis, goias, e vc ?";
         $bogus{"$ude"} = 4;
      }
      else {
         $resposta = random_txt("unknowmsg");
      }
   }
   elsif (check($cleaned,"TCHAU")) {
      $resposta = "tchauzinho...";
   }
   elsif (check($cleaned,"BOT")) {
      if ($msgtype == 1)  {
         $resposta = "o que eh isso?";
      }
      else {
         $resposta = random_txt("unknowmsg");
      }
   }
   elsif ((check($cleaned,"SEU")) && (check($cleaned,"NOME"))) {
      if ($msgtype == 1) {
         $resposta = "meu nome eh Lia e o seu?";
      }
      else {
         $resposta = random_txt("unknowmsg");
      }
   }
   elsif ((check($cleaned,"TER")) && (check($cleaned,"FOTO")) ) {
      if ($msgtype == 1) {
         $resposta = random_txt("naomsg");
      }
      else {
         $resposta = random_txt("unknowmsg");
      }
   }
   elsif (check($cleaned,"COMO")) {
      if ( $msgtype == 1 ) { 
         $resposta = "Eu sou loira, alta, magrinha e bronzeada. olhos azuis"; 
         $bogus{"$ude"} = 7;
      }
      else {
         $resposta = random_txt("unknowmsg");
      }
   }
   elsif (check($cleaned,"FAZ")) {
      if ($msgtype == 1) { 
         $resposta = "eu soh estudo.";
         $bogus{"$ude"} = 6;
      }
      elsif ($msgtype == 2) {
         $resposta = random_txt("naomsg");
      }
      else {
         $resposta = random_txt("unknowmsg");
      }
   }
   elsif (check($cleaned,"LEMBRA")) {
      if ($msgtype == 1) {
         $resposta = "ah eh!";
      }
      elsif ($msgtype == 2) {
         $resposta = "foi mau.. to com soninho... :)";
      }
      else {
         $resposta = random_txt("naomsg");
      }
   }
   elsif (check($cleaned,"ESTUDAR")) {
      if ($msgtype == 1)  {
         $resposta = "eu estudo no gabriel issa. conhece ?";
         $bogus{"$ude"} = 5;
      }
      elsif ($msgtype == 2) {
         $resposta = "eu gosto de estudar...";
      }
      else {
         $resposta = random_txt("unknowmsg");
      }
   }
   elsif (check($cleaned,"BADWORD")) {
      $resposta = random_txt("badmsg");
   }
   elsif (check($cleaned,"BEIJO")) {
      $resposta = ":***";
   }
   elsif (check($cleaned,"STRUCK")) {
      $resposta = "o struck eh o kra mais gostosao que eu conheco!";
   }
   elsif (check($cleaned,"PCHAZARD")) {
      $resposta = "o pchazard eh mto fodao";
   }
   elsif (check($cleaned,"CARTI")) {
      $resposta = "o carti eh meio viado realmente...";  #:)
   }
   elsif (check($cleaned,"WOHNRATH")) {
      $resposta = "nao consigo nem tcla direito esse nick! =) ele assiste muito Thunder Cats :)";
   }
   elsif ($bogus{"$ude"} == 1) {
      $resposta = random_txt("bommsg");
      $bogus{"$ude"} = 0;
   }
   elsif ($bogus{"$ude"} == 2) {
      $resposta = random_txt("othermsg");
      $bogus{"$ude"} = 0;
   }
   elsif ($bogus{"$ude"} == 3) {
      if ((check($cleaned,"SIM")) || (check($cleaned,"TENHO")))  {
         $resposta = "ah! que pena! :(";
      }
      elsif (check($cleaned,"NAO")) {
         $resposta = "oba! :)";
      }
      else {
         $resposta = random_txt("unknowmsg");
      }
      $bogus{"$ude"} = 0;
   }
   elsif ($bogus{"$ude"} == 4) {
      $resposta = "voce gosta de onde mora?";
      $bogus{"$ude"} = 1;
   }
   elsif ($bogus{"$ude"} == 5) {
      if ((check($cleaned,"CONHECO")) || (check($cleaned,"SIM")) || (check($cleaned,"CLARO")))  {
         $resposta = "passa lah qq dia desses :)";
      }
      else {
         $resposta = "naum faz mal :)";
      }
      $bogus{"$ude"} = 0;
   }
   elsif ($bogus{"$ude"} == 6)  {
      $resposta = "o que voce faz?";
      $bogus{"$ude"} = 1;
   }
   elsif ($bogus{"$ude"} == 7) {
      $resposta = "como voce eh?";
      $bogus{"$ude"} = 1;
   }
   else  {
      if ($msgtype == 1) {
         $resposta = random_txt("unknowmsg");
      }
      else {
         $resposta = random_txt("othermsg");
      }
   }

   if ($para eq "$meunick") { privmsg($de,$resposta); }
   else { privmsg($para, $resposta); }
}

sub limpatxts
{
   # cria um padrao formal para as conversas para serem facilmente
   # manipuladas pelo bot. alguma sugestao ?
   my $txt = uc(" $_[0] ");

   foreach $ce (get_array("conversionlist"))
   {
      my ($giria, $formal) = split(':', $ce);
      #debuga("limpatxt giria=($giria) formal=($formal)");
      $txt=~s/$giria/$formal/ge;
   }
   return $txt;
}

sub check
{
   my $frase = $_[0];
   my @palavras = @_;
   
   for $i (1 .. $#palavras)
   {
      #print STDERR "check=($palavras[$i])\n" ;
      if (thereis($palavras[$i],$frase) == 0)
      {
#         print STDERR "falhou na palavra ($palavras[$i])\n";
         return 0;
      }
   }
   return 1;
}

sub thereis
{
   my ($sub,$txt) = @_;
   $p = strpos($txt,$sub);
   if ($p > -1)
   {
      return 1;
   }
   else
   {
      return 0;
   }
}

sub privmsg
{
   my ($para,$msg) = @_;
   return if ($msg eq '');
   print $sock "PRIVMSG $para :$msg\n";
   debuga("[msg($para)] $msg");
   #print "[+] $para: $msg\n";
}

sub strpos
{
   my ($str,$substr) = @_;
   for $i (0 .. length($str))
   {
      return $i if (substr($str,$i,length($substr)) eq $substr);
   }
   return (-1);
}



sub array_find
{
   my ($entrada, @lista) = @_;
   $entrada = uc($entrada);

   for $e (@lista)
   {
      return(1) if (uc($e) eq $entrada);
   }
   return(0);
}

sub rehash
{
   # Rele as configuracoes...
   # Util para recarregar opcoes sem ter que reiniciar o bot ;)

   debuga('REHASH function started.');
   (@joinmsg, @unknowmsg, @oimsg, @naomsg, @bommsg, @malmsg,  @othermsg, @quitmsg, @partmsg,
   @scums, @badmsg, @ownerlist, @conversionlist) = "";

   open(CONF,"< lia.conf") || sub
   {
      debuga("<REHASH> Erro abrindo arquivo lia.conf: $!");
      print STDERR "[-] Erro abrindo arquivo de configuracao lia.conf: $!\n";
      exit(-1);
   };
   $current_session = '';
   K: while (<CONF>)
   {
      chop;
      next if ($_ eq '');
      next if (/^#/i);
      
      $linha = $_;
      if (substr($linha,0,1) eq ':')
      {
         substr($linha,0,1) = "";
         $current_session = $linha;
         debuga("<REHASH> Entrando na secao ($current_session)");
         next K;
      }
      elsif (substr($linha,0,1) eq '=')
      {
         substr($linha,0,1) = "";
         $valor = $linha;
         if (substr($valor,0,1) eq "\"")
         {
            substr($valor,0,1) = "";
            substr($valor,strpos("\"", $valor),1) = "";
         }
         push @$current_session, $valor;
#         debuga("<REHASH> Adicionado o valor ($valor) na secao ($current_session)");
      }
   }
   close(CONF);
   debuga('REHASH finished.');
}

sub datahora
{
   my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
   my @meses   = ('Jan','Fev','Mar','Abr','Mai','Jun','Jul','Ago','Set','Out','Nov','Dez');
   my @semanas = ('Dom','Seg','Ter','Qua','Qui','Sex','Sab');
   $year += 1900;
   return(sprintf("%02d $meses[$mon] $year $semanas[$wday] %02d:%02d:%02d", $mday, $hour, $min, $sec));
}

sub debuga
{
   $hora = datahora();
   print FDEBUG "$hora  $_[0]\n";
   FDEBUG->flush();
}

sub testhash
{
   my @arraies = ('joinmsg', 'unknowmsg', 'oimsg', 'naomsg',
                  'bommsg' , 'malmsg',  'othermsg', 'quitmsg', 'partmsg',
                  'scums', 'badmsg', 'ownerlist', 'conversionlist');
   foreach $an (@arraies)
   {
      print STDERR "Mostrando a array \@$an:\n";
      $p = -1;
      foreach $av (@$an)
      {
         $p++;
         print STDERR "$p\t-->\t\"$av\"\n";
      }
   }
}

sub is_owner
{
   $nick = uc($_[0]);

   foreach $dono (get_array("ownerlist"))
   {
      $dono = uc($dono);
      return(1) if ($dono eq $nick);
   }
   return(0);
}

sub run_owner_command
{
   my $origem    = $_[0];
   my $linha     = $_[1];
   substr($linha,0,1) = " ";
   
   my $comando   = uc((split(' ',$linha))[0]);
   my $argumento = substr($linha, strpos($comando, uc($linha))+length($comando)+3, length($linha));

   if (!is_owner($origem))
   {
      debuga("--> run_owner_command as non-owner :)");
      privmsg($origem, random_txt("denymsg"));
      return;
   }
   if ($comando eq 'EXECUTA')
   {
      $resposta=`$argumento`;
      $resposta=~s/\n/  \\  /g;
#      foreach $linha (split("\n", $saida))
#      {
#         $resposta="$linha";
#         select(undef,undef,undef,0.25);
#      }
      debuga("--> EXECUTA comando=($cmd) feito por $origem executado.");
   }
   elsif ($comando eq 'REHASH')
   {
      debuga("--> REHASH pedido por $origem");
      sighup();
      debuga("--> REHASH feito por $origem executado.");
      $resposta="REHASH pronto queridinho :)";
   }
   elsif ($comando eq 'PRIVATE')
   {
      debuga("--> PRIVATE pedido por $origem para $argumento.");
      $private=$argumento;
      $myowner=$origem;
      $resposta="$private sendo logado...";
   }
   elsif ($comando eq 'TALK')
   {
      debuga("--> TALK de $origem para $private.");
      privmsg($private,$argumento);
      return;
   }
   else
   {
      $resposta="Comando \"$comando\" nao reconhecido.";
   }

   if ($para eq "$meunick") { privmsg($de,$resposta); }
   else { privmsg($para, $resposta); }

}

sub get_array
{
   my $array_name = $_[0];
   return(@$array_name);
}

sub random_txt
{
   my @the_array = get_array("$_[0]");
   return($the_array[rand(@the_array)]);
}
